-- MODULE:
--   Bin2Hs.hs
--
-- PURPOSE:
--   Program to convert binary files into a Haskell source file.
--   Was used to generate KConfigCgt.hs.
--
-- AUTHOR:
--   Stephen Thompson <stephen@solarflare.org.uk>
--
-- COPYRIGHT:
--   Copyright (C) Stephen Thompson, 2011.
--
--   This file is part of Knights Map Editor.
--
--   Knights Map Editor is free software: you can redistribute it
--   and/or modify it under the terms of the GNU General Public
--   License as published by the Free Software Foundation, either
--   version 3 of the License, or (at your option) any later version.
--
--   Knights Map Editor is distributed in the hope that it will be
--   useful, but WITHOUT ANY WARRANTY; without even the implied
--   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--   See the GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with Knights Map Editor. If not, see
--   <http://www.gnu.org/licenses/>.


module Main where

import Data.Char
import Data.List
import System.IO

-- override showLitChar's poor handling of '"'
myShowLitChar :: Char -> String -> String
myShowLitChar '\"' tail = '\\' : '"' : tail
myShowLitChar x    tail = showLitChar x tail

myWriteString foo handle = do
  let (h,t) = splitAt 30 foo
  let outStr = foldr myShowLitChar "" h
  hPutStr handle "  \""
  hPutStr handle outStr
  case t of [] -> hPutStrLn handle "\""
            _ -> do
              hPutStrLn handle "\","
              myWriteString t handle

main = do
  inputFile <- openBinaryFile "e:/cygwin/home/stephen/projects/da-new/src/kconfig/kconfig.cgt" ReadMode
  outputFile <- openFile "e:/cygwin/home/stephen/non-svn/haskell-gold-parser/KConfigCgt.hs" WriteMode
  inputFileContents <- hGetContents inputFile
  hPutStrLn outputFile "module KConfigCgt where"
  hPutStrLn outputFile "kConfigCgt = concat ["
  myWriteString inputFileContents outputFile
  hPutStrLn outputFile "  ]"
  hClose outputFile
